package fr.iut.pm.movieapplication.model

import androidx.room.ColumnInfo
import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.PrimaryKey
import androidx.room.Relation
import java.util.Date

@Entity(tableName = "movies_table")
data class Movie(
    @ColumnInfo(name = "adult")
    var adult: Boolean,
    @ColumnInfo(name = "budget")
    var budget: Int,
    @ColumnInfo(name = "genres")
    var genres: Array<Genre>,
    @ColumnInfo(name = "homepage")
    var homePage: String?,
    @PrimaryKey
    @ColumnInfo(name = "id")
    var movieId: Int,
    @ColumnInfo(name = "original_language")
    var originalLanguage: String,
    @ColumnInfo(name = "original_title")
    var originalTitle: String,
    var overview: String?,
    var popularity: Int,
    //var posterPath : String?,
    @Embedded
    var productionCompanies: Array<ProductionCompany>,
    @Relation(
        parentColumn = "movieId",
        entityColumn = ""
    )
    var productionCountries: Array<ProductionCountry>,
    var releaseDate: Date,
    var revenue: Int,
    var runtime: Int?,
    //var spokenLanguages : Array<SpokenLanguage>,
    var status: String,
    var tagLine: String?,
    var title: String,
    @ColumnInfo(name = "vote_average")
    var voteAverage: Number,
    @ColumnInfo(name = "vote_count")
    var voteCount : Int


    ) {


    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as Movie

        if (movieId != other.movieId) return false

        return true
    }

    override fun hashCode(): Int {
        return movieId
    }
}